function gpfnarx_demo()
% Demo of GP-FNARX with Wiener-Hammerstein Benchmark data which has been
% corrupted by noise.


[traindata, testdata] = GetWHData();
model = gpfnarx(traindata);

% Evaluate model mean with test data
mu = model.predictFITC(testdata.y, testdata.u);
testyCut = testdata.y(length(testdata.y)-length(mu)+1:length(testdata.y));

figure
plot(testyCut,'.-')
hold on
plot(mu,'r.-')
legend('Test data','GP-FNARX prediction mean')

end



function [traindata,testdata] = GetWHData()
% Loads Wiener-Hammerstein Benchmark data

sigman = 0.0754; % SNR = 10 dB

load WienerHammerBenchMark.mat

t = 0:1/fs:(numel(uBenchMark)-1)/fs;
iBoundary = 80000;
testu = uBenchMark(1:iBoundary);
testy = yBenchMark(1:iBoundary);
testdata = iddata(testy, testu, 1/fs);

% Inject some noise only on train set output
if true
    yBenchMarkNoise = yBenchMark + sigman * randn(size(yBenchMark));
else
    yBenchMarkNoise = yBenchMark;
end

traindata = iddata(yBenchMarkNoise(iBoundary:end), uBenchMark(iBoundary:end), 1/fs);
end


